#! /usr/bin/python
## -*- coding: utf-8 -*-

##
##  HARK Middleware
##  Copyright (C) 2013-2014 by Honda Research Institute Japan Co., Ltd.
##
##  $Id:$
##

from harkmw.HarkError import HARKError

def xml_node_path(node) :
    parent = node.parentNode
    if parent is None :
        return "/%s" % node.name

    else :
        return "%s/%s" % (xml_node_path(parent), node.name)

def xml_attribute(node, name, required=True, default=None) :
    if node.getAttributeNode(name) :
        return node.attributes[name].value

    elif required :
        raise HARKError("Element %s does not have attribute with name '%s'" % (xml_node_path(node), name))

    else :
        return default

# end of file

