/*

 */

#ifndef LIBHARKMW__LIBHARMKW_H__INCLUDED
#define LIBHARKMW__LIBHARMKW_H__INCLUDED 1

#include "py3c.h"
#include <typeinfo>

#define HARKMW_CATCH_EXCEPTION()					\
    catch(HARK::BaseException *ex){					\
	std::stringstream ss;						\
	ex->print(ss);							\
	delete ex;							\
	return PyErr_Format(PyExc_RuntimeError, "HARK-Middleware: HARK exception thrown at %s:%d (%s): %s", __FILE__, __LINE__, __FUNCTION__, ss.str().c_str()); \
    }catch(std::exception &ex){						\
	return PyErr_Format(PyExc_RuntimeError, "HARK-Middleware: standard exception thrown at %s:%d: %s (type: %s)", __FILE__, __LINE__, ex.what(), typeid(ex).name()); \
    }catch(...){							\
	return PyErr_Format(PyExc_RuntimeError, "HARK-Middleware: some exception thrown at %s:%d", __FILE__, __LINE__); \
    }

#define HARKMW_CATCH_EXCEPTION_RETURNS(retval)				\
    catch(HARK::BaseException *ex){					\
	std::stringstream ss;						\
	ex->print(ss);							\
	delete ex;							\
	PyErr_Format(PyExc_RuntimeError, "HARK-Middleware: HARK exception thrown at %s:%d (%s): %s", __FILE__, __LINE__, __FUNCTION__, ss.str().c_str()); \
	return (retval);						\
    }catch(std::exception &ex){						\
	PyErr_Format(PyExc_RuntimeError, "HARK-Middleware: standard exception thrown at %s:%d: %s (type: %s)", __FILE__, __LINE__, ex.what(), typeid(ex).name()); \
	return (retval);						\
    }catch(...){							\
	PyErr_Format(PyExc_RuntimeError, "HARK-Middleware: some exception thrown at %s:%d", __FILE__, __LINE__); \
	return (retval);						\
    }

#endif
